import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import Plugin from '../../session/plugin';
import { Spacer, Group, Button, Input, Label, Selection, Checkbox, Dropdown, Console } from '../../session/elements';
import { actions } from '../../session/store/connections';
var resources = ['isometric'].reduce(function (prev, item) {
  var _objectSpread2;

  return _objectSpread({}, prev, (_objectSpread2 = {}, _objectSpread2[item] = require('!!url-loader!awv3-icons/32x32/' + item + '.png'), _objectSpread2));
}, {});

var Import =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(Import, _Plugin);

  function Import(session, args) {
    var _this;

    _this = _Plugin.call(this, session, _objectSpread({
      type: 'Import',
      icon: 'isometric',
      resources: resources
    }, args)) || this;
    var input = new Button(_assertThisInitialized(_assertThisInitialized(_this)), {
      name: 'Import',
      format: Button.Format.Upload
    });
    input.observe(function (state) {
      return state.lastEvent;
    }, function (_ref) {
      var result = _ref.result,
          filename = _ref.filename;

      _this.store.dispatch(actions.readStream(_this.connection.id, _this.feature, result));

      _this.store.dispatch(actions.setName(_this.connection.id, _this.feature, filename));
    });

    _this.addElement(new Group(_assertThisInitialized(_assertThisInitialized(_this)), {
      format: Group.Format.Table,
      children: [input]
    }));

    return _this;
  }

  return Import;
}(Plugin);

export { Import as default };