import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _class, _dec2, _class2;

import React from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import { actions as connectionActions } from '../../session/store/connections';
import Plugin from '../../session/plugin';
import { emptyObject, emptyArray } from '../../session/helpers';
var resources = ['isometric'].reduce(function (prev, item) {
  var _objectSpread2;

  return _objectSpread({}, prev, (_objectSpread2 = {}, _objectSpread2[item] = require('!!url-loader!awv3-icons/32x32/' + item + '.png'), _objectSpread2));
}, {});

var Member =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Member, _React$Component);

  function Member() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      value: undefined
    };

    _this.update = function (event) {
      if (event.key === 'Enter') {
        _this.context.plugin.connection.execute("_C.CADApplication.SetExpressions(" + _this.props.objectId + ", [\"" + _this.props.memberKey + "\"], [" + _this.state.value + "], 1);");
      }
    };

    _this.setValue = function (value) {
      return _this.setState({
        value: value
      });
    };

    return _this;
  }

  var _proto = Member.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        items = _this$props.items,
        memberKey = _this$props.memberKey;
    var value = this.state.value;
    var item = items[memberKey];
    return React.createElement("input", {
      name: memberKey,
      value: value === undefined ? item.expression || item.value : value,
      onValue: this.setValue,
      onLastEvent: this.update
    });
  };

  return Member;
}(React.Component);

Member.contextTypes = {
  plugin: PropTypes.object
};
var Members = (_dec = connect(function (state, _ref) {
  var _ref2, _state$connections$co;

  var id = _ref.id,
      connection = _ref.connection;
  return {
    members: (_ref2 = (_state$connections$co = state.connections[connection].tree[id]) === null || _state$connections$co === void 0 ? void 0 : _state$connections$co.members) !== null && _ref2 !== void 0 ? _ref2 : emptyArray
  };
}), _dec(_class =
/*#__PURE__*/
function (_React$Component2) {
  _inheritsLoose(Members, _React$Component2);

  function Members() {
    return _React$Component2.apply(this, arguments) || this;
  }

  var _proto2 = Members.prototype;

  _proto2.render = function render() {
    var _this$props2 = this.props,
        id = _this$props2.id,
        members = _this$props2.members,
        filter = _this$props2.filter;
    var keys = Object.keys(members).filter(function (member) {
      return !filter.length || filter.indexOf(member) != -1;
    });
    return keys.map(function (key) {
      return React.createElement(Member, {
        key: key,
        objectId: id,
        memberKey: key,
        items: members
      });
    });
  };

  return Members;
}(React.Component)) || _class);
var Root = (_dec2 = connect(function (state, props) {
  var _ref3;

  var plugin = state.plugins[props.id];
  var connection = (_ref3 = plugin === null || plugin === void 0 ? void 0 : plugin.connection) !== null && _ref3 !== void 0 ? _ref3 : state.globals.activeConnection;
  return {
    connection: connection,
    feature: plugin === null || plugin === void 0 ? void 0 : plugin.feature
  };
}), _dec2(_class2 =
/*#__PURE__*/
function (_React$Component3) {
  _inheritsLoose(Root, _React$Component3);

  function Root() {
    return _React$Component3.apply(this, arguments) || this;
  }

  var _proto3 = Root.prototype;

  _proto3.render = function render() {
    var _this$props3 = this.props,
        connection = _this$props3.connection,
        filter = _this$props3.filter,
        feature = _this$props3.feature;
    return feature ? React.createElement("group", {
      format: "Table"
    }, React.createElement(Members, {
      id: feature,
      connection: connection,
      filter: filter
    })) : null;
  };

  return Root;
}(React.Component)) || _class2);

var _default =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(_default, _Plugin);

  function _default(session, args) {
    return _Plugin.call(this, session, _objectSpread({
      type: 'Members',
      icon: 'feature',
      filter: [],
      resources: resources
    }, args)) || this;
  }

  var _proto4 = _default.prototype;

  _proto4.render = function render() {
    return React.createElement(Root, {
      id: this.id,
      filter: this.filter
    });
  };

  return _default;
}(Plugin);

export { _default as default };