import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Expr from './expr';

var Call =
/*#__PURE__*/
function (_Expr) {
  _inheritsLoose(Call, _Expr);

  function Call() {
    return _Expr.apply(this, arguments) || this;
  }

  var _proto = Call.prototype;

  _proto.unparse = function unparse() {
    return this.func.unparse() + '(' + this.args.map(function (arg) {
      return arg.unparse();
    }).join(', ') + ')';
  };

  return Call;
}(Expr);

Call._fields = ['func', 'args'];
export { Call as default };