import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Element from '../element';

var Button =
/*#__PURE__*/
function (_Element) {
  _inheritsLoose(Button, _Element);

  function Button(plugin, options) {
    if (options.children) {
      options.children = options.children.map(function (item) {
        return item instanceof Element ? item.id : item;
      });
    }

    return _Element.call(this, plugin, _objectSpread({
      type: Element.Type.Button,
      icon: '',
      format: Button.Format.Default,
      value: false
    }, options)) || this;
  }

  return Button;
}(Element);

Button.Format = {
  Default: 'Default',
  Toggle: 'Toggle',
  Upload: 'Upload',
  Color: 'Color',
  Menu: 'Menu'
};
export { Button as default };