import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Element from '../element';

var Selection =
/*#__PURE__*/
function (_Element) {
  _inheritsLoose(Selection, _Element);

  function Selection(plugin, options) {
    if (options === void 0) {
      options = {};
    }

    if (options.children) {
      options.children = options.children.map(function (item) {
        return item instanceof Element ? item.id : item;
      });
    }

    return _Element.call(this, plugin, _objectSpread({
      type: Element.Type.Selection,
      types: ['Mesh'],
      limit: Infinity,
      items: [],
      active: false,
      selectObjects: false
    }, options)) || this;
  }

  return Selection;
}(Element);

export { Selection as default };