import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Element from '../element';

var Slider =
/*#__PURE__*/
function (_Element) {
  _inheritsLoose(Slider, _Element);

  function Slider(plugin, options) {
    return _Element.call(this, plugin, _objectSpread({
      type: Element.Type.Slider,
      positions: {
        0: '0',
        100: '100'
      },
      value: 0,
      min: 0,
      max: 100,
      step: 1
    }, options)) || this;
  }

  return Slider;
}(Element);

export { Slider as default };