import _regeneratorRuntime from "@babel/runtime/regenerator";

/*
 * Abstract syntax tree of the ClassCad language.
 * API is closely based on python ast module, see there for class/method help.
 */
var Ast =
/*#__PURE__*/
function () {
  function Ast() {
    var i = 0;

    for (var _iterator = this.iter_fields(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      var _ref2;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref2 = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref2 = _i.value;
      }

      var _ref3 = _ref2,
          name = _ref3[0],
          field = _ref3[1];
      this[name] = (_ref = i++, _ref < 0 || arguments.length <= _ref ? undefined : arguments[_ref]);
    }
  }

  var _proto = Ast.prototype;
  _proto.iter_fields =
  /*#__PURE__*/
  _regeneratorRuntime.mark(function iter_fields() {
    var _iterator2, _isArray2, _i2, _ref4, field;

    return _regeneratorRuntime.wrap(function iter_fields$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _iterator2 = this.constructor._fields, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();

          case 1:
            if (!_isArray2) {
              _context.next = 7;
              break;
            }

            if (!(_i2 >= _iterator2.length)) {
              _context.next = 4;
              break;
            }

            return _context.abrupt("break", 16);

          case 4:
            _ref4 = _iterator2[_i2++];
            _context.next = 11;
            break;

          case 7:
            _i2 = _iterator2.next();

            if (!_i2.done) {
              _context.next = 10;
              break;
            }

            return _context.abrupt("break", 16);

          case 10:
            _ref4 = _i2.value;

          case 11:
            field = _ref4;
            _context.next = 14;
            return [field, this[field]];

          case 14:
            _context.next = 1;
            break;

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, iter_fields, this);
  });
  _proto.iter_child_nodes =
  /*#__PURE__*/
  _regeneratorRuntime.mark(function iter_child_nodes() {
    var _iterator3, _isArray3, _i3, _ref5, _ref6, name, field, _iterator4, _isArray4, _i4, _ref7, item;

    return _regeneratorRuntime.wrap(function iter_child_nodes$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _iterator3 = this.iter_fields(), _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();

          case 1:
            if (!_isArray3) {
              _context2.next = 7;
              break;
            }

            if (!(_i3 >= _iterator3.length)) {
              _context2.next = 4;
              break;
            }

            return _context2.abrupt("break", 37);

          case 4:
            _ref5 = _iterator3[_i3++];
            _context2.next = 11;
            break;

          case 7:
            _i3 = _iterator3.next();

            if (!_i3.done) {
              _context2.next = 10;
              break;
            }

            return _context2.abrupt("break", 37);

          case 10:
            _ref5 = _i3.value;

          case 11:
            _ref6 = _ref5, name = _ref6[0], field = _ref6[1];

            if (!(field instanceof Ast)) {
              _context2.next = 17;
              break;
            }

            _context2.next = 15;
            return field;

          case 15:
            _context2.next = 35;
            break;

          case 17:
            if (!(field instanceof Array)) {
              _context2.next = 35;
              break;
            }

            _iterator4 = field, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();

          case 19:
            if (!_isArray4) {
              _context2.next = 25;
              break;
            }

            if (!(_i4 >= _iterator4.length)) {
              _context2.next = 22;
              break;
            }

            return _context2.abrupt("break", 35);

          case 22:
            _ref7 = _iterator4[_i4++];
            _context2.next = 29;
            break;

          case 25:
            _i4 = _iterator4.next();

            if (!_i4.done) {
              _context2.next = 28;
              break;
            }

            return _context2.abrupt("break", 35);

          case 28:
            _ref7 = _i4.value;

          case 29:
            item = _ref7;

            if (!(item instanceof Ast)) {
              _context2.next = 33;
              break;
            }

            _context2.next = 33;
            return item;

          case 33:
            _context2.next = 19;
            break;

          case 35:
            _context2.next = 1;
            break;

          case 37:
          case "end":
            return _context2.stop();
        }
      }
    }, iter_child_nodes, this);
  });
  _proto.walk =
  /*#__PURE__*/
  _regeneratorRuntime.mark(function walk() {
    var _iterator5, _isArray5, _i5, _ref8, child;

    return _regeneratorRuntime.wrap(function walk$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this;

          case 2:
            _iterator5 = this.iter_child_nodes(), _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();

          case 3:
            if (!_isArray5) {
              _context3.next = 9;
              break;
            }

            if (!(_i5 >= _iterator5.length)) {
              _context3.next = 6;
              break;
            }

            return _context3.abrupt("break", 17);

          case 6:
            _ref8 = _iterator5[_i5++];
            _context3.next = 13;
            break;

          case 9:
            _i5 = _iterator5.next();

            if (!_i5.done) {
              _context3.next = 12;
              break;
            }

            return _context3.abrupt("break", 17);

          case 12:
            _ref8 = _i5.value;

          case 13:
            child = _ref8;
            return _context3.delegateYield(child.walk(), "t0", 15);

          case 15:
            _context3.next = 3;
            break;

          case 17:
          case "end":
            return _context3.stop();
        }
      }
    }, walk, this);
  });
  return Ast;
}();

export { Ast as default };