import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Arc from './arc';
import BaseGraphics from './base';

var Circle =
/*#__PURE__*/
function (_Arc) {
  _inheritsLoose(Circle, _Arc);

  function Circle() {
    return _Arc.apply(this, arguments) || this;
  }

  var _proto = Circle.prototype;

  _proto.updateFromGeomParams = function updateFromGeomParams(geomParams) {
    // call grandparent (BaseGraphics) method, skipping parent (Arc) one
    BaseGraphics.prototype.updateFromGeomParams.call(this, geomParams);
    this.updateWithAngles(geomParams.center, geomParams.radius, 0, 2 * Math.PI, geomParams.scale);
    this.updateMetaBox();
  };

  return Circle;
}(Arc);

export { Circle as default };