import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Element from '../element';

var Group =
/*#__PURE__*/
function (_Element) {
  _inheritsLoose(Group, _Element);

  function Group(plugin, options) {
    if (options === void 0) {
      options = {};
    }

    if (options.children) {
      options.children = options.children.filter(function (item) {
        return item;
      }).map(function (item) {
        return item instanceof Element ? item.id : item;
      });
    }

    return _Element.call(this, plugin, _objectSpread({
      type: Element.Type.Group,
      format: Group.Format.Default,
      limit: undefined
    }, options)) || this;
  }

  return Group;
}(Element);

Group.Format = {
  Default: 'Default',
  Buttons: 'Buttons',
  Inputs: 'Inputs',
  Rows: 'Rows',
  Table: 'Table',
  Collapse: 'Collapse',
  Tabs: 'Tabs'
};
export { Group as default };