import { combineReducers } from 'redux';
import { reducer as globals } from './globals';
import { reducer as plugins, actions as pluginActions } from './plugins';
import { reducer as elements, actions as elementActions } from './elements';
import { reducer as connections } from './connections';
import { reducer as collections } from './collections';
export var reducer = combineReducers({
  globals: globals,
  plugins: plugins,
  elements: elements,
  connections: connections,
  collections: collections
});